diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/model/node.cc ns-3.40/src/network/model/node.cc
--- ns-3.39/src/network/model/node.cc	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/model/node.cc	2023-09-27 13:30:37.854839600 -0700
@@ -23,13 +23,13 @@
 #include "application.h"
 #include "net-device.h"
 #include "node-list.h"
+#include "packet.h"
 
 #include "ns3/assert.h"
 #include "ns3/boolean.h"
 #include "ns3/global-value.h"
 #include "ns3/log.h"
 #include "ns3/object-vector.h"
-#include "ns3/packet.h"
 #include "ns3/simulator.h"
 #include "ns3/uinteger.h"
 
@@ -199,16 +199,14 @@
     NS_LOG_FUNCTION(this);
     m_deviceAdditionListeners.clear();
     m_handlers.clear();
-    for (std::vector<Ptr<NetDevice>>::iterator i = m_devices.begin(); i != m_devices.end(); i++)
+    for (auto i = m_devices.begin(); i != m_devices.end(); i++)
     {
         Ptr<NetDevice> device = *i;
         device->Dispose();
         *i = nullptr;
     }
     m_devices.clear();
-    for (std::vector<Ptr<Application>>::iterator i = m_applications.begin();
-         i != m_applications.end();
-         i++)
+    for (auto i = m_applications.begin(); i != m_applications.end(); i++)
     {
         Ptr<Application> application = *i;
         application->Dispose();
@@ -222,14 +220,12 @@
 Node::DoInitialize()
 {
     NS_LOG_FUNCTION(this);
-    for (std::vector<Ptr<NetDevice>>::iterator i = m_devices.begin(); i != m_devices.end(); i++)
+    for (auto i = m_devices.begin(); i != m_devices.end(); i++)
     {
         Ptr<NetDevice> device = *i;
         device->Initialize();
     }
-    for (std::vector<Ptr<Application>>::iterator i = m_applications.begin();
-         i != m_applications.end();
-         i++)
+    for (auto i = m_applications.begin(); i != m_applications.end(); i++)
     {
         Ptr<Application> application = *i;
         application->Initialize();
@@ -256,8 +252,7 @@
     {
         if (!device)
         {
-            for (std::vector<Ptr<NetDevice>>::iterator i = m_devices.begin(); i != m_devices.end();
-                 i++)
+            for (auto i = m_devices.begin(); i != m_devices.end(); i++)
             {
                 Ptr<NetDevice> dev = *i;
                 dev->SetPromiscReceiveCallback(MakeCallback(&Node::PromiscReceiveFromDevice, this));
@@ -276,7 +271,7 @@
 Node::UnregisterProtocolHandler(ProtocolHandler handler)
 {
     NS_LOG_FUNCTION(this << &handler);
-    for (ProtocolHandlerList::iterator i = m_handlers.begin(); i != m_handlers.end(); i++)
+    for (auto i = m_handlers.begin(); i != m_handlers.end(); i++)
     {
         if (i->handler.IsEqual(handler))
         {
@@ -343,7 +338,7 @@
                          << packet->GetUid());
     bool found = false;
 
-    for (ProtocolHandlerList::iterator i = m_handlers.begin(); i != m_handlers.end(); i++)
+    for (auto i = m_handlers.begin(); i != m_handlers.end(); i++)
     {
         if (!i->device || (i->device == device))
         {
@@ -366,8 +361,7 @@
     NS_LOG_FUNCTION(this << &listener);
     m_deviceAdditionListeners.push_back(listener);
     // and, then, notify the new listener about all existing devices.
-    for (std::vector<Ptr<NetDevice>>::const_iterator i = m_devices.begin(); i != m_devices.end();
-         ++i)
+    for (auto i = m_devices.begin(); i != m_devices.end(); ++i)
     {
         listener(*i);
     }
@@ -377,9 +371,7 @@
 Node::UnregisterDeviceAdditionListener(DeviceAdditionListener listener)
 {
     NS_LOG_FUNCTION(this << &listener);
-    for (DeviceAdditionListenerList::iterator i = m_deviceAdditionListeners.begin();
-         i != m_deviceAdditionListeners.end();
-         i++)
+    for (auto i = m_deviceAdditionListeners.begin(); i != m_deviceAdditionListeners.end(); i++)
     {
         if ((*i).IsEqual(listener))
         {
@@ -393,9 +385,7 @@
 Node::NotifyDeviceAdded(Ptr<NetDevice> device)
 {
     NS_LOG_FUNCTION(this << device);
-    for (DeviceAdditionListenerList::iterator i = m_deviceAdditionListeners.begin();
-         i != m_deviceAdditionListeners.end();
-         i++)
+    for (auto i = m_deviceAdditionListeners.begin(); i != m_deviceAdditionListeners.end(); i++)
     {
         (*i)(device);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/model/node.h ns-3.40/src/network/model/node.h
--- ns-3.39/src/network/model/node.h	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/model/node.h	2023-09-27 13:30:37.854839600 -0700
@@ -20,8 +20,9 @@
 #ifndef NODE_H
 #define NODE_H
 
+#include "net-device.h"
+
 #include "ns3/callback.h"
-#include "ns3/net-device.h"
 #include "ns3/object.h"
 #include "ns3/ptr.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/model/node-list.cc ns-3.40/src/network/model/node-list.cc
--- ns-3.39/src/network/model/node-list.cc	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/model/node-list.cc	2023-09-27 13:30:37.854839600 -0700
@@ -165,7 +165,7 @@
 NodeListPriv::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    for (std::vector<Ptr<Node>>::iterator i = m_nodes.begin(); i != m_nodes.end(); i++)
+    for (auto i = m_nodes.begin(); i != m_nodes.end(); i++)
     {
         Ptr<Node> node = *i;
         node->Dispose();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/model/packet.cc ns-3.40/src/network/model/packet.cc
--- ns-3.39/src/network/model/packet.cc	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/model/packet.cc	2023-09-27 13:30:37.854839600 -0700
@@ -490,7 +490,7 @@
                     NS_ASSERT(!constructor.IsNull());
                     ObjectBase* instance = constructor();
                     NS_ASSERT(instance != nullptr);
-                    Chunk* chunk = dynamic_cast<Chunk*>(instance);
+                    auto chunk = dynamic_cast<Chunk*>(instance);
                     NS_ASSERT(chunk != nullptr);
                     if (item.type == PacketMetadata::Item::HEADER)
                     {
@@ -662,7 +662,7 @@
 uint32_t
 Packet::Serialize(uint8_t* buffer, uint32_t maxSize) const
 {
-    uint32_t* p = reinterpret_cast<uint32_t*>(buffer);
+    auto p = reinterpret_cast<uint32_t*>(buffer);
     uint32_t size = 0;
 
     // if nix-vector exists, serialize it
@@ -825,7 +825,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    const uint32_t* p = reinterpret_cast<const uint32_t*>(buffer);
+    auto p = reinterpret_cast<const uint32_t*>(buffer);
 
     // read nix-vector
     NS_ASSERT(!m_nixVector);
@@ -934,7 +934,7 @@
 Packet::AddByteTag(const Tag& tag) const
 {
     NS_LOG_FUNCTION(this << tag.GetInstanceTypeId().GetName() << tag.GetSerializedSize());
-    ByteTagList* list = const_cast<ByteTagList*>(&m_byteTagList);
+    auto list = const_cast<ByteTagList*>(&m_byteTagList);
     TagBuffer buffer = list->Add(tag.GetInstanceTypeId(), tag.GetSerializedSize(), 0, GetSize());
     tag.Serialize(buffer);
 }
@@ -944,7 +944,7 @@
 {
     NS_LOG_FUNCTION(this << tag.GetInstanceTypeId().GetName() << tag.GetSerializedSize());
     NS_ABORT_MSG_IF(end < start, "Invalid byte range");
-    ByteTagList* list = const_cast<ByteTagList*>(&m_byteTagList);
+    auto list = const_cast<ByteTagList*>(&m_byteTagList);
     TagBuffer buffer = list->Add(tag.GetInstanceTypeId(),
                                  tag.GetSerializedSize(),
                                  static_cast<int32_t>(start),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/model/packet-metadata.cc ns-3.40/src/network/model/packet-metadata.cc
--- ns-3.39/src/network/model/packet-metadata.cc	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/model/packet-metadata.cc	2023-09-27 13:30:37.854839600 -0700
@@ -44,7 +44,7 @@
 PacketMetadata::DataFreeList::~DataFreeList()
 {
     NS_LOG_FUNCTION(this);
-    for (iterator i = begin(); i != end(); i++)
+    for (auto i = begin(); i != end(); i++)
     {
         PacketMetadata::Deallocate(*i);
     }
@@ -620,8 +620,8 @@
         n = PACKET_METADATA_DATA_M_DATA_SIZE;
     }
     size += n - PACKET_METADATA_DATA_M_DATA_SIZE;
-    uint8_t* buf = new uint8_t[size];
-    PacketMetadata::Data* data = (PacketMetadata::Data*)buf;
+    auto buf = new uint8_t[size];
+    auto data = (PacketMetadata::Data*)buf;
     data->m_size = n;
     data->m_count = 1;
     data->m_dirtyEnd = 0;
@@ -632,7 +632,7 @@
 PacketMetadata::Deallocate(PacketMetadata::Data* data)
 {
     NS_LOG_FUNCTION(data);
-    uint8_t* buf = (uint8_t*)data;
+    auto buf = (uint8_t*)data;
     delete[] buf;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/model/packet-tag-list.cc ns-3.40/src/network/model/packet-tag-list.cc
--- ns-3.39/src/network/model/packet-tag-list.cc	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/model/packet-tag-list.cc	2023-09-27 13:30:37.854839600 -0700
@@ -47,7 +47,7 @@
     void* p = std::malloc(sizeof(TagData) + dataSize - 1);
     // The matching frees are in RemoveAll and RemoveWriter
 
-    TagData* tag = new (p) TagData;
+    auto tag = new (p) TagData;
     tag->size = dataSize;
     return tag;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/model/socket.cc ns-3.40/src/network/model/socket.cc
--- ns-3.39/src/network/model/socket.cc	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/model/socket.cc	2023-09-27 13:30:37.854839600 -0700
@@ -22,10 +22,10 @@
 #include "socket.h"
 
 #include "node.h"
+#include "packet.h"
 #include "socket-factory.h"
 
 #include "ns3/log.h"
-#include "ns3/packet.h"
 
 #include <limits>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/model/socket.h ns-3.40/src/network/model/socket.h
--- ns-3.39/src/network/model/socket.h	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/model/socket.h	2023-09-27 13:30:37.854839600 -0700
@@ -23,14 +23,14 @@
 #define NS3_SOCKET_H
 
 #include "address.h"
+#include "net-device.h"
+#include "tag.h"
 
 #include "ns3/callback.h"
 #include "ns3/inet-socket-address.h"
 #include "ns3/inet6-socket-address.h"
-#include "ns3/net-device.h"
 #include "ns3/object.h"
 #include "ns3/ptr.h"
-#include "ns3/tag.h"
 
 #include <stdint.h>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/model/tag-buffer.cc ns-3.40/src/network/model/tag-buffer.cc
--- ns-3.39/src/network/model/tag-buffer.cc	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/model/tag-buffer.cc	2023-09-27 13:30:37.854839600 -0700
@@ -118,7 +118,7 @@
 TagBuffer::WriteDouble(double v)
 {
     NS_LOG_FUNCTION(this << v);
-    uint8_t* buf = (uint8_t*)&v;
+    auto buf = (uint8_t*)&v;
     for (uint32_t i = 0; i < sizeof(double); ++i, ++buf)
     {
         WriteU8(*buf);
@@ -171,7 +171,7 @@
 {
     NS_LOG_FUNCTION(this);
     double v;
-    uint8_t* buf = (uint8_t*)&v;
+    auto buf = (uint8_t*)&v;
     for (uint32_t i = 0; i < sizeof(double); ++i, ++buf)
     {
         *buf = ReadU8();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/test/buffer-test.cc ns-3.40/src/network/test/buffer-test.cc
--- ns-3.39/src/network/test/buffer-test.cc	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/test/buffer-test.cc	2023-09-27 13:30:37.854839600 -0700
@@ -363,7 +363,7 @@
     NS_TEST_ASSERT_MSG_EQ(sizeBuffer, ct.size(), "Buffer bad size");
     const uint8_t* evilBuffer = buffer.PeekData();
     NS_TEST_ASSERT_MSG_NE(evilBuffer, 0, "Buffer PeekData failed");
-    uint8_t* cBuf = (uint8_t*)malloc(sizeBuffer);
+    auto cBuf = (uint8_t*)malloc(sizeBuffer);
     uint32_t copyLen = buffer.CopyData(cBuf, sizeBuffer);
     NS_TEST_ASSERT_MSG_EQ(copyLen, sizeBuffer, "CopyData return bad size");
     for (uint32_t i = 0; i < sizeBuffer; i++)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/test/packet-metadata-test.cc ns-3.40/src/network/test/packet-metadata-test.cc
--- ns-3.39/src/network/test/packet-metadata-test.cc	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/test/packet-metadata-test.cc	2023-09-27 13:30:37.854839600 -0700
@@ -381,7 +381,7 @@
         if (item.type == PacketMetadata::Item::HEADER)
         {
             Callback<ObjectBase*> constructor = item.tid.GetConstructor();
-            HistoryHeaderBase* header = dynamic_cast<HistoryHeaderBase*>(constructor());
+            auto header = dynamic_cast<HistoryHeaderBase*>(constructor());
             if (header == nullptr)
             {
                 goto error;
@@ -397,7 +397,7 @@
         else if (item.type == PacketMetadata::Item::TRAILER)
         {
             Callback<ObjectBase*> constructor = item.tid.GetConstructor();
-            HistoryTrailerBase* trailer = dynamic_cast<HistoryTrailerBase*>(constructor());
+            auto trailer = dynamic_cast<HistoryTrailerBase*>(constructor());
             if (trailer == nullptr)
             {
                 goto error;
@@ -413,7 +413,7 @@
         got.push_back(item.currentSize);
     }
 
-    for (std::list<int>::iterator i = got.begin(), j = expected.begin(); i != got.end(); i++, j++)
+    for (auto i = got.begin(), j = expected.begin(); i != got.end(); i++, j++)
     {
         NS_ASSERT(j != expected.end());
         if (*j != *i)
@@ -425,12 +425,12 @@
 error:
     std::ostringstream failure;
     failure << "PacketMetadata error. Got:\"";
-    for (std::list<int>::iterator i = got.begin(); i != got.end(); i++)
+    for (auto i = got.begin(); i != got.end(); i++)
     {
         failure << *i << ", ";
     }
     failure << "\", expected: \"";
-    for (std::list<int>::iterator j = expected.begin(); j != expected.end(); j++)
+    for (auto j = expected.begin(); j != expected.end(); j++)
     {
         failure << *j << ", ";
     }
@@ -872,7 +872,7 @@
     REM_HEADER(p3, 2);
     CHECK_HISTORY(p3, 1, 11);
 
-    uint8_t* buf = new uint8_t[p3->GetSize()];
+    auto buf = new uint8_t[p3->GetSize()];
     p3->CopyData(buf, p3->GetSize());
     std::string msg = std::string(reinterpret_cast<const char*>(buf), p3->GetSize());
     delete[] buf;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/test/packet-test-suite.cc ns-3.40/src/network/test/packet-test-suite.cc
--- ns-3.39/src/network/test/packet-test-suite.cc	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/test/packet-test-suite.cc	2023-09-27 13:30:37.854839600 -0700
@@ -632,7 +632,7 @@
 
     NS_TEST_EXPECT_MSG_EQ(packet->GetSize(), 11, "trivial");
 
-    uint8_t* buf = new uint8_t[packet->GetSize()];
+    auto buf = new uint8_t[packet->GetSize()];
     packet->CopyData(buf, packet->GetSize());
 
     std::string msg = std::string(reinterpret_cast<const char*>(buf), packet->GetSize());
@@ -811,7 +811,7 @@
         p1->AddPacketTag(c1);
 
         uint32_t serializedSize = p1->GetSerializedSize();
-        uint8_t* buffer = new uint8_t[serializedSize + 16];
+        auto buffer = new uint8_t[serializedSize + 16];
         p1->Serialize(buffer, serializedSize);
 
         Ptr<Packet> p2 = Create<Packet>(buffer, serializedSize, true);
@@ -846,7 +846,7 @@
         CHECK(p1, 3, E(10, 0, 1000), E(11, 0, 1000), E(12, 0, 1000));
 
         uint32_t serializedSize = p1->GetSerializedSize();
-        uint8_t* buffer = new uint8_t[serializedSize];
+        auto buffer = new uint8_t[serializedSize];
         p1->Serialize(buffer, serializedSize);
 
         Ptr<Packet> p2 = Create<Packet>(buffer, serializedSize, true);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/drop-tail-queue.h ns-3.40/src/network/utils/drop-tail-queue.h
--- ns-3.39/src/network/utils/drop-tail-queue.h	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/utils/drop-tail-queue.h	2023-09-27 13:30:37.854839600 -0700
@@ -18,7 +18,7 @@
 #ifndef DROPTAIL_H
 #define DROPTAIL_H
 
-#include "ns3/queue.h"
+#include "queue.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/error-channel.cc ns-3.40/src/network/utils/error-channel.cc
--- ns-3.39/src/network/utils/error-channel.cc	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/utils/error-channel.cc	2023-09-27 13:30:37.854839600 -0700
@@ -19,10 +19,11 @@
 
 #include "error-channel.h"
 
+#include "simple-net-device.h"
+
 #include "ns3/log.h"
 #include "ns3/node.h"
 #include "ns3/packet.h"
-#include "ns3/simple-net-device.h"
 #include "ns3/simulator.h"
 
 namespace ns3
@@ -86,9 +87,7 @@
                    Ptr<SimpleNetDevice> sender)
 {
     NS_LOG_FUNCTION(p << protocol << to << from << sender);
-    for (std::vector<Ptr<SimpleNetDevice>>::const_iterator i = m_devices.begin();
-         i != m_devices.end();
-         ++i)
+    for (auto i = m_devices.begin(); i != m_devices.end(); ++i)
     {
         Ptr<SimpleNetDevice> tmp = *i;
         if (tmp == sender)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/error-channel.h ns-3.40/src/network/utils/error-channel.h
--- ns-3.39/src/network/utils/error-channel.h	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/utils/error-channel.h	2023-09-27 13:30:37.854839600 -0700
@@ -19,11 +19,12 @@
 #ifndef ERROR_CHANNEL_H
 #define ERROR_CHANNEL_H
 
+#include "error-model.h"
+#include "mac48-address.h"
+#include "simple-channel.h"
+
 #include "ns3/channel.h"
-#include "ns3/error-model.h"
-#include "ns3/mac48-address.h"
 #include "ns3/nstime.h"
-#include "ns3/simple-channel.h"
 
 #include <vector>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/error-model.cc ns-3.40/src/network/utils/error-model.cc
--- ns-3.39/src/network/utils/error-model.cc	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/utils/error-model.cc	2023-09-27 13:30:37.854839600 -0700
@@ -471,7 +471,7 @@
         return false;
     }
     auto uid = p->GetUid();
-    for (PacketListCI i = m_packetList.begin(); i != m_packetList.end(); i++)
+    for (auto i = m_packetList.begin(); i != m_packetList.end(); i++)
     {
         if (uid == *i)
         {
@@ -538,7 +538,7 @@
         return false;
     }
     m_timesInvoked += 1;
-    for (PacketListCI i = m_packetList.begin(); i != m_packetList.end(); i++)
+    for (auto i = m_packetList.begin(); i != m_packetList.end(); i++)
     {
         if (m_timesInvoked - 1 == *i)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/ethernet-header.h ns-3.40/src/network/utils/ethernet-header.h
--- ns-3.39/src/network/utils/ethernet-header.h	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/utils/ethernet-header.h	2023-09-27 13:30:37.854839600 -0700
@@ -20,8 +20,9 @@
 #ifndef ETHERNET_HEADER_H
 #define ETHERNET_HEADER_H
 
+#include "mac48-address.h"
+
 #include "ns3/header.h"
-#include "ns3/mac48-address.h"
 
 #include <string>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/ipv4-address.cc ns-3.40/src/network/utils/ipv4-address.cc
--- ns-3.39/src/network/utils/ipv4-address.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/ipv4-address.cc	2023-09-27 13:30:37.854839600 -0700
@@ -52,7 +52,7 @@
     NS_LOG_FUNCTION(this << mask);
     if (*mask == '/')
     {
-        uint32_t plen = static_cast<uint32_t>(std::atoi(++mask));
+        auto plen = static_cast<uint32_t>(std::atoi(++mask));
         NS_ASSERT(plen <= 32);
         if (plen > 0)
         {
@@ -113,7 +113,7 @@
 Ipv4Mask::GetLoopback()
 {
     NS_LOG_FUNCTION_NOARGS();
-    static Ipv4Mask loopback = Ipv4Mask("255.0.0.0");
+    static Ipv4Mask loopback("255.0.0.0");
     return loopback;
 }
 
@@ -121,7 +121,7 @@
 Ipv4Mask::GetZero()
 {
     NS_LOG_FUNCTION_NOARGS();
-    static Ipv4Mask zero = Ipv4Mask("0.0.0.0");
+    static Ipv4Mask zero("0.0.0.0");
     return zero;
 }
 
@@ -129,7 +129,7 @@
 Ipv4Mask::GetOnes()
 {
     NS_LOG_FUNCTION_NOARGS();
-    static Ipv4Mask ones = Ipv4Mask("255.255.255.255");
+    static Ipv4Mask ones("255.255.255.255");
     return ones;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/ipv6-address.h ns-3.40/src/network/utils/ipv6-address.h
--- ns-3.39/src/network/utils/ipv6-address.h	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/ipv6-address.h	2023-09-27 13:30:37.858839800 -0700
@@ -20,11 +20,11 @@
 #ifndef IPV6_ADDRESS_H
 #define IPV6_ADDRESS_H
 
+#include "ipv4-address.h"
 #include "mac8-address.h"
 
 #include "ns3/address.h"
 #include "ns3/attribute-helper.h"
-#include "ns3/ipv4-address.h"
 
 #include <cstring>
 #include <ostream>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/mac16-address.cc ns-3.40/src/network/utils/mac16-address.cc
--- ns-3.39/src/network/utils/mac16-address.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/mac16-address.cc	2023-09-27 13:30:37.858839800 -0700
@@ -201,7 +201,7 @@
 {
     NS_LOG_FUNCTION_NOARGS();
 
-    static Mac16Address broadcast = Mac16Address("ff:ff");
+    static Mac16Address broadcast("ff:ff");
     return broadcast;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/mac48-address.cc ns-3.40/src/network/utils/mac48-address.cc
--- ns-3.39/src/network/utils/mac48-address.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/mac48-address.cc	2023-09-27 13:30:37.858839800 -0700
@@ -201,7 +201,7 @@
 Mac48Address::GetBroadcast()
 {
     NS_LOG_FUNCTION_NOARGS();
-    static Mac48Address broadcast = Mac48Address("ff:ff:ff:ff:ff:ff");
+    static Mac48Address broadcast("ff:ff:ff:ff:ff:ff");
     return broadcast;
 }
 
@@ -209,7 +209,7 @@
 Mac48Address::GetMulticastPrefix()
 {
     NS_LOG_FUNCTION_NOARGS();
-    static Mac48Address multicast = Mac48Address("01:00:5e:00:00:00");
+    static Mac48Address multicast("01:00:5e:00:00:00");
     return multicast;
 }
 
@@ -217,7 +217,7 @@
 Mac48Address::GetMulticast6Prefix()
 {
     NS_LOG_FUNCTION_NOARGS();
-    static Mac48Address multicast = Mac48Address("33:33:00:00:00:00");
+    static Mac48Address multicast("33:33:00:00:00:00");
     return multicast;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/net-device-queue-interface.cc ns-3.40/src/network/utils/net-device-queue-interface.cc
--- ns-3.39/src/network/utils/net-device-queue-interface.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/net-device-queue-interface.cc	2023-09-27 13:30:37.858839800 -0700
@@ -17,11 +17,12 @@
  * Author: Stefano Avallone <stefano.avallone@.unina.it>
  */
 
-#include "ns3/net-device-queue-interface.h"
+#include "net-device-queue-interface.h"
+
+#include "queue-item.h"
+#include "queue-limits.h"
 
 #include "ns3/abort.h"
-#include "ns3/queue-item.h"
-#include "ns3/queue-limits.h"
 #include "ns3/uinteger.h"
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/output-stream-wrapper.cc ns-3.40/src/network/utils/output-stream-wrapper.cc
--- ns-3.39/src/network/utils/output-stream-wrapper.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/output-stream-wrapper.cc	2023-09-27 13:30:37.858839800 -0700
@@ -32,7 +32,7 @@
     : m_destroyable(true)
 {
     NS_LOG_FUNCTION(this << filename << filemode);
-    std::ofstream* os = new std::ofstream();
+    auto os = new std::ofstream();
     os->open(filename, filemode);
     m_ostream = os;
     FatalImpl::RegisterStream(m_ostream);
